<?php
	$rcsid = "\$Fuller: myprograms/htbm/web/bmadmin.php,v 1.43 2004/12/14 12:58:39 fullermd Exp $";

	/* Include our stuff */
	$rootdir = ".";
	include("${rootdir}/php/main.php");

	/* Start up */
	$db = db_connect();

	/* Auth */
	if($admin_auth_req==1)
	{ admin_auth(); }

	/* Pull some variables we need */
	$commit = $_REQUEST['commit'];
	$amode = $_REQUEST['amode'];

	/* The global config stuff */
	$confenc = $_REQUEST['conf'];
	$conf = unserialize(base64_decode($confenc));

	/* Save the place to bounce back to */
	$bounceback = $_REQUEST['bounceback'];
	if(isset($bounceback))
		$conf['bounceback'] = $bounceback;
	else
		$bounceback = $conf['bounceback'];

	/* Re-encode */
	$confenc = base64_encode(serialize($conf));


	/* Our various modes */
	if($amode=="edit")
	{
		/* Create/edit a bookmark */
		$mark_id = $_REQUEST['mark_id'];
		if(!isset($mark_id))
			$mark_id=0;
		$mid_q = db_quote($mark_id);

		/* Just do the header here */
		print_head("Bookmark Administration", $rcsid);

		if(isset($commit))
		{
			/* Commit general info changes */
			$url = $_REQUEST['url'];
			$title = $_REQUEST['title'];
			$comment = $_REQUEST['comment'];

			/* Build up a backward link */
			$url_e = urlencode($url);
			$title_e = urlencode($title);
			$comment_e = urlencode($comment);

			$backlink = "$self?amode=edit&amp;mark_id=$mark_id&amp;"
					. "url=$url_e&amp;title=$title_e&amp;"
					. "comment=$comment_e&amp;conf=$confenc";

			/* Do some sanity checking */
			$warnstr = "";
			if(!$url)
			{
				print <<< _EOF_
<h1>ERROR: Need URL specified!</h1>
<p>
 <a href="$backlink">Re-edit</a>
</p>

_EOF_;
				print_foot();
				exit(1);
			}
			$urlp = parse_url($url);
			if(strlen($urlp['scheme']) < 1)
			{
				$warnstr .= "<li>No URL scheme specified, assuming "
						. "http://.  You should edit this bookmark "
						. "if this isn't what you want.</li>";
				$url = "http://" . $url;
			}
			if(!$title)
			{
				$warnstr .= "<li>No title entered, using URL.  You may want "
						. "to edit this bookmark and add a real title."
						. "</li>";
				$title = $url;
			}

			/* Escape info for safety */
			$url_q = db_quote($url);
			$title_q = db_quote($title);
			$comment_q = db_quote($comment);

			/* Stuff the data */
			$newmark=0;
			if($mark_id==0)
			{
				/* New bookmark */
				$newmark=1;
				db_query("BEGIN");

				$mid_q = "nextval('bookmarks_mark_id_seq')";
				$querystr = "INSERT INTO bookmarks "
						. "(mark_id,url,title,comment,created) "
						. "VALUES ($mid_q,$url_q,$title_q,$comment_q,"
						. "CURRENT_TIMESTAMP)";
				db_query($querystr);

				/* Get our mark_id */
				$mid_q = "currval('bookmarks_mark_id_seq')";
				$query = "SELECT $mid_q AS mid";
				$result = db_query($query);
				$row = db_getrow($result);
				$mark_id = db_dequote($row['mid']);
				$mid_q = db_quote($mark_id);
				db_qfree($result);

				/*
				 * New bookmarks need to be stuck in their category right
				 * off.
				 */
				$parent_q = db_quote($_REQUEST['parent']);
				$query = "INSERT INTO bm_links (mark_id,parent) "
						. "VALUES ($mid_q,$parent_q)";
				db_query($query);

				/* 'nuff */
				db_query("COMMIT");
			}
			else
			{
				/* Edit */
				$querystr = "UPDATE bookmarks SET "
						. "url=$url_q, title=$title_q, "
						. "comment=$comment_q "
						. "WHERE mark_id=$mid_q";
				db_query($querystr);
			}


			/* If we get here, success! */
			if($newmark==1)
				print("<h1>New bookmark added!</h1>\n");
			else
				print("<h1>Bookmark info updated!</h1>\n");

			if(strlen($warnstr)>0)
				print("<h2>Warnings:</h2><ul>$warnstr</ul>\n");
		}
		else if(isset($_REQUEST['ed_chcat']))
		{
			/* Change a parent category */
			$parent = $_REQUEST['parent'];
			$old_parent = $_REQUEST['old_parent'];

			/* See if we actually need to do crap */
			if($parent!=$old_parent)
			{
				$parent_q = db_quote($parent);
				$old_q = db_quote($old_parent);
				$query = "UPDATE bm_links SET "
						. "parent=$parent_q "
						. "WHERE parent=$old_q "
						. "AND mark_id=$mid_q";
				db_query($query);
				/* XXX Error-checking */
				print("<h1>Parent category updated!</h1>\n");
			}
		}
		else if(isset($_REQUEST['ed_addcat']))
		{
			/* Add a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "INSERT INTO bm_links "
					. "(mark_id,parent) "
					. "VALUES ($mid_q,$parent_q)";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>New parent category added!</h1>\n");
		}
		else if(isset($_REQUEST['ed_delcat']))
		{
			/* Delete a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "DELETE FROM bm_links "
					. "WHERE parent=$parent_q "
					. "AND mark_id=$mid_q";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>Parent category deleted!</h1>\n");
		}

		/* Now, print the edit form */
		if($mark_id!=0)
		{
			/* We're editing */
			$mid_q = db_quote($mark_id);

			$querystr = "SELECT b.mark_id,url,title,comment,bl.parent "
					. "FROM bookmarks b LEFT JOIN bm_links bl USING (mark_id) "
					. "WHERE b.mark_id=$mid_q";
			$result = db_query($querystr);
			$nrows = db_numrows($result);
			if($nrows == 0)
			{
				print("<p>Bookmark ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php?conf=$confenc"
						. "#$bounceback\">"
						. "Back to Bookmarks</a></p>\n");
				exit;
			}

			/* Build up the info */
			$bminfo = array();
			$bminfo['parents'] = array();
			while($info = db_getrow($result))
			{
				$bminfo['mark_id'] = db_dequote($info['mark_id']);
				$bminfo['url'] = db_dequote($info['url']);
				$bminfo['title'] = db_dequote($info['title']);
				$bminfo['comment'] = db_dequote($info['comment']);
				array_unshift($bminfo['parents'],
						db_dequote($info['parent']));
			}
			db_qfree($result);
		}
		else
		{
			/* We're creating, so initialize something empty */
			$bminfo = array();
			$bminfo['mark_id'] = 0;
			$bminfo['url'] = "";
			$bminfo['title'] = "";
			$bminfo['comment'] = "";
			$bminfo['parents'] = array('0' => '-1');
		}

		/* Print out the form */
		if($mark_id==0)
			print("<h1>Add new bookmark</h1>\n");
		else
			print("<h1>Edit bookmark</h1>\n");

		/* Slap up the form */
		print <<< _EOF_
<form method="get" action="bookmarks.php#$bounceback">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;
		print_bmark_form($bminfo);
		print <<< _EOF_
<form method="get" action="bookmarks.php#$bounceback">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;

		/* That's it for creating/editing */
		print_foot();
		exit(0);
	}
	else if($amode=="dele")
	{
		/* Delete existing bookmark */
		$mark_id = $_REQUEST['mark_id'];
		$mid_q = db_quote($mark_id);

		if(isset($commit))
		{
			/* Do the actual deletion */
			$querystr = "BEGIN";
			db_query($querystr);

			/* Delete the links */
			$mid_q = db_quote($mark_id);
			$querystr = "DELETE FROM bm_links WHERE mark_id=$mid_q";
			db_query($querystr);

			/* Delete the entry */
			$querystr = "DELETE FROM bookmarks WHERE mark_id=$mid_q";
			db_query($querystr);

			/* End this transaction */
			$querystr = "COMMIT";
			db_query($querystr);

			/* Success */
			$bounceback = ereg_replace("--[0-9]+$", "", $bounceback);
			if($conf['debug']==1)
			{
				/* If in debug mode, print a message */
				print_head("Bookmark Administration", $rcsid);
				print("<p>Ex-bookmark number $mark_id deleted!</p>\n");
				print("<p>\n");
				print("<a href=\"bookmarks.php?conf=$confenc"
						. "#$bounceback\">"
						. "Back to bookmarks</a>\n");
				print("</p>\n");
				print_foot();
				exit(0);
			}
			else
			{
				/* Else, just bounce */
				header("Location: bookmarks.php?conf=$confenc"
						. "#$bounceback");
				exit(0);
			}
		}

		print_head("Bookmark Administration", $rcsid);

		/* First, look up its info */
		$querystr = <<< _EOF_
SELECT
  b.mark_id AS mid,url,title,comment,c.name AS cname
FROM
  bookmarks b FULL OUTER JOIN bm_links bm USING (mark_id)
    LEFT JOIN categories c ON c.cat_id=bm.parent
WHERE
  b.mark_id=$mid_q

_EOF_;
		$result = db_query($querystr);
		$nrows = db_numrows($result);
		if($nrows == 0)
		{
			print("<p>Bookmark ID not found!</p>\n");
			print("<p><a href=\"bookmarks.php?conf=$confenc"
					. "#$bounceback\">"
					. "Back to Bookmarks</a></p>\n");
			print_foot();
			exit(1);
		}

		$bminfo = array();
		$bminfo['parents'] = array();
		while($info = db_getrow($result))
		{
			$bminfo['mark_id'] = db_dequote($info['mid']);
			$bminfo['url'] = db_dequote($info['url']);
			$bminfo['title'] = db_dequote($info['title']);
			$bminfo['comment'] = db_dequote($info['comment']);
			array_unshift($bminfo['parents'],
					db_dequote($info['cname']));
		}
		db_qfree($result);

		/* Now, print out the form */
		print <<< _EOF_
<h1>CONFIRM DELETE</h1>
<form action="$self" method="post">

_EOF_;
		print_bmark_form($bminfo);
		print <<< _EOF_
<div>
<input type="hidden" name="amode" value="dele" />
<input type="hidden" name="conf" value="$confenc" />
<input type="hidden" name="mark_id" value="$mark_id" />
</div>
<p>
Are you <em>SURE</em> you want to permamently delete this bookmark?
</p>
<p>
<input type="submit" name="commit" value="Delete" />
</p>
</form>
<form method="get" action="bookmarks.php#$bounceback">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;
		/* That's it for deletion */
		print_foot();
		exit(0);
	}
	else if($amode=="catedit")
	{
		/* Create/edit a category */
		$cat_id = $_REQUEST['cat_id'];
		if(!isset($cat_id))
			$cat_id=0;
		$cid_q = db_quote($cat_id);

		/* Just print the header here */
		print_head("Bookmark Administration", $rcsid);

		if(isset($commit))
		{
			/* Commit in info we're passed */
			$cat_id = $_REQUEST['cat_id'];
			$name = $_REQUEST['name'];

			/* Run away! */
			$name_q = db_quote($name);

			/* Write edited category information */
			$newcat=0;
			if($cat_id==0)
			{
				/* Brand spankin' new */
				$newcat=1;
				db_query("BEGIN");

				/* Add the category */
				$cid_q = "nextval('categories_cat_id_seq')";
				$querystr = "INSERT INTO categories "
						. "(cat_id,name) "
						. "VALUES ($cid_q,$name_q)";
				db_query($querystr);

				/* Get the category ID */
				$cid_q = "currval('categories_cat_id_seq')";
				$query = "SELECT $cid_q AS cid";
				$result = db_query($query);
				$row = db_getrow($result);
				$cat_id = db_dequote($row['cid']);
				$cid_q = db_quote($cat_id);
				db_qfree($result);

				/* Add its parent */
				$parent_q = db_quote($_REQUEST['parent']);
				$query = "INSERT INTO cat_links "
						. "(cat_id,parent) "
						. "VALUES ($cid_q,$parent_q)";
				db_query($query);

				/* 's'it */
				db_query("COMMIT");
			}
			else
			{
				/* Edit */
				$querystr = "UPDATE categories SET "
						. "name=$name_q "
						. "WHERE cat_id=$cid_q";
				db_query($querystr);
			}

			/* Success */
			if($newcat==1)
				print("<h1>New category added!</h1>\n");
			else
				print("<h1>Category info updated!</h1>\n");
		}
		else if(isset($_REQUEST['ed_chpar']))
		{
			/* Change parent category */
			$parent = $_REQUEST['parent'];
			$old_parent = $_REQUEST['old_parent'];

			/* See if we actually need to do crap */
			if($parent!=$old_parent)
			{
				$parent_q = db_quote($parent);
				$old_q = db_quote($old_parent);
				$query = "UPDATE cat_links SET "
						. "parent=$parent_q "
						. "WHERE parent=$old_q "
						. "AND cat_id=$cid_q";
				db_query($query);
				/* XXX Error-checking */
				print("<h1>Parent category updated!</h1>\n");
			}
		}
		else if(isset($_REQUEST['ed_addpar']))
		{
			/* Add a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "INSERT INTO cat_links "
					. "(cat_id,parent) "
					. "VALUES ($cid_q,$parent_q)";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>New parent category added!</h1>\n");
		}
		else if(isset($_REQUEST['ed_delpar']))
		{
			/* Delete a parent category */
			$parent = $_REQUEST['parent'];
			$parent_q = db_quote($parent);
			$query = "DELETE FROM cat_links "
					. "WHERE parent=$parent_q "
					. "AND cat_id=$cid_q";
			db_query($query);
			/* XXX Error-checking */
			print("<h1>Parent category deleted!</h1>\n");
		}

		/* Now, see what info we need to display */
		if($cat_id!=0)
		{
			/* We're editing a pre-existing category */
			$cid_q = db_quote($cat_id);
			$querystr = "SELECT name,parent "
					. "FROM categories c LEFT JOIN cat_links cl USING (cat_id) "
					. "WHERE c.cat_id=$cid_q";
			$result = db_query($querystr);
			$nrows = db_numrows($result);
			if($nrows == 0)
			{
				print("<h1>Error</h1>\n<p>Category ID $cat_id not "
						. "found!</p>\n<p><a href=\"bookmarks.php?"
						. "conf=$confenc#$bounceback\">"
						. "Back to Bookmarks</a></p>\n");
				print_foot();
				exit(1);
			}

			/*
		 	 * We have to parse this out into a nice format to send into
		 	 * print_cat_form();
		 	 */
			$catinfo = array();
			$catinfo['parents'] = array();
			$catinfo['cat_id'] = $cat_id;
			while($info = db_getrow($result))
			{
				$catinfo['name'] = db_dequote($info['name']);
				array_unshift($catinfo['parents'],
						db_dequote($info['parent']));
			}
			db_qfree($result);
		}
		else
		{
			/* Fill out a dummy structure */
			$catinfo = array();
			$catinfo['cat_id'] = 0;
			$catinfo['name'] = "";
			$catinfo['parents'] = array("0" => "-1");
		}

		if($cat_id==0)
			print("<h1>Add new category</h1>\n");
		else
			print("<h1>Edit category</h1>\n");

		print <<< _EOF_
<form method="get" action="bookmarks.php#$bounceback">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;
		print_cat_form($catinfo);
		print <<< _EOF_
<form method="get" action="bookmarks.php#$bounceback">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;

		/* That's all for here */
		print_foot();
		exit(0);
	}
	else if($amode=="catdele")
	{
		/* Delete existing bookmark */
		$cat_id = $_REQUEST['cat_id'];
		$cid_q = db_quote($cat_id);

		if(isset($commit))
		{
			/*
			 * Do the deletion.
			 * First, see if we CAN delete it.  If it has children, we'll
			 * just bail right now.  We need to add more flexibility
			 * here.
			 */
			$querystr = "SELECT COUNT(DISTINCT bl.mark_id) AS nmarks, "
					. "COUNT(DISTINCT cl.cat_id) AS ncats "
					. "FROM categories c FULL JOIN bm_links bl "
					. "ON (bl.parent=c.cat_id) FULL JOIN cat_links cl "
					. "ON (cl.parent=c.cat_id) "
					. "WHERE c.cat_id=$cid_q";
			$result = db_query($querystr);
			$temp = db_getrow($result);
			$nbm = db_dequote($temp['nmarks']);
			$nsc = db_dequote($temp['ncats']);
			db_qfree($result);

			/* See what we have, error out if necessary */
			if($nbm>0 || $nsc>0)
			{
				print <<< _EOF_
<h1>Error</h1>
<p>
 Category $cat_id has children ($nsc categories, $nbm bookmarks) 
 , and thus can't be deleted.
</p>
<p>
 <a href="bookmarks.php?conf=$confenc#$bounceback">Back to bookmarks</a>
</p>

_EOF_;
				/* synhi: ' */
				print_foot();
				exit(1);
			}

			/* Begin this transaction */
			db_query("BEGIN");

			/* Delete an entry */
			$querystr = "DELETE FROM cat_links WHERE cat_id=$cid_q";
			db_query($querystr);

			$querystr = "DELETE FROM categories WHERE cat_id=$cid_q";
			db_query($querystr);

			/* Commit this transaction */
			db_query("COMMIT");

			/* Success */
			$bounceback = ereg_replace("-[0-9]+$", "", $bounceback);
			if($conf['debug']==1)
			{
				/* If in debug mode, print a message */
				print_head("Bookmark Administration", $rcsid);
				print("<p>Ex-category number $cat_id deleted!</p>\n"
						. "<p><a href=\"bookmarks.php?conf=$confenc"
						. "#$bounceback\">"
						. "Back to bookmarks</a></p>\n");
				print_foot();
				exit(0);
			}
			else
			{
				/* Else, just bounce */
				header("Location: bookmarks.php?conf=$confenc"
						. "#$bounceback");
				exit(0);
			}
		}

		print_head("Bookmark Administration", $rcsid);

		/* Lookup this bookmark's info */
		$querystr = <<< _EOF_
SELECT
  c1.name AS myname,
  c2.name AS parent
FROM
  categories c1 LEFT JOIN cat_links cl USING (cat_id)
    LEFT JOIN categories c2 ON c2.cat_id=cl.parent
WHERE
  c1.cat_id=$cid_q

_EOF_;

		$result = db_query($querystr);
		$nrows = db_numrows($result);
		if($nrows == 0)
		{
			print("<h1>Error</h1>\n<p>Category ID not found!</p>\n"
					. "<p><a href=\"bookmarks.php?conf=$confenc"
					. "#$bounceback\">"
					. "Back to Bookmarks</a></p>\n");
			print_foot();
			exit(1);
		}

		/* Build catinfo */
		$catinfo = array();
		$catinfo['parents'] = array();
		$catinfo['cat_id'] = $cat_id;
		while($info = db_getrow($result))
		{
			$catinfo['name'] = db_dequote($info['myname']);
			array_unshift($catinfo['parents'],
					db_dequote($info['parent']));
		}
		db_qfree($result);

		print <<< _EOF_
<h1>CONFIRM DELETE</h1>
<form action="$self" method="post">

_EOF_;

		print_cat_form($catinfo);

		print <<< _EOF_
 <p>
  Are you <em>SURE</em> you want to permamently delete this category?
 </p>
 <p>
  <input type="hidden" name="amode" value="catdele" />
  <input type="hidden" name="conf" value="$confenc" />
  <input type="hidden" name="cat_id" value="$cat_id" />
  <input type="submit" name="commit" value="Commit" />
 </p>
</form>
<form method="get" action="bookmarks.php#$bounceback">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;

		/* That's it */
		print_foot();
		exit(0);
	}
	else if($amode=="backup")
	{
		/* Do backup stuff */
		$bakmode = $_REQUEST['bakmode'];
		if($bakmode == "download")
		{
			/* Build an XML backup doc and send it */
			/* First off, let it be downloaded */
			header("Content-type: application/octet-stream");
			header("Content-disposition: attachment; filename=bookmarks.xml");

			/* Some boilerplate */
			print("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n"
					. "<!DOCTYPE htbmbak SYSTEM \"htbmbak.dtd\">\n"
					. "<htbmbak version=\"1.0\">\n");

			/* Hard-flip the debug switch off; no extra output */
			$conf['debug'] = 0;

			/* Now, start listing off categories */
			$query = "SELECT c.cat_id,name,parent "
					. "FROM categories c LEFT JOIN cat_links cl "
					. "USING (cat_id) ORDER BY c.cat_id";
			$result = db_query($query);

			print(" <categories>\n");
			$lastcat = -1;
			$first = 1;
			while($row = db_getrow($result))
			{
				$cid = db_dequote($row['cat_id']);
				$name = db_dequote($row['name']);
				$parent = db_dequote($row['parent']);

				/* Print the outer stuff if we're new */
				if($cid!=$lastcat)
				{
					if($first==0)
						print("  </category>\n");
					else
						$first=0;

					/* Do a few requisite entity subs */
					$name = ereg_replace("&", "&amp;", $name);
					$name = ereg_replace("<", "&lt;", $name);
					$name = ereg_replace('"', "&quot;", $name);
					print("  <category id=\"$cid\" name=\"$name\">\n");
					$lastcat = $cid;
				}

				/* We always have parents to describe */
				if(is_numeric($parent))
					print("   <parent id=\"$parent\" />\n");
			}
			if($lastcat != -1)
				print("  </category>\n");
			print(" </categories>\n");

			/* Do the same for bookmarks */
			$query = "SELECT b.mark_id,url,title,comment,created,parent "
					. "FROM bookmarks b LEFT JOIN bm_links bl "
					. "USING (mark_id) ORDER BY b.mark_id";
			$result = db_query($query);

			print(" <bookmarks>\n");
			$lastbm = -1;
			$first = 1;
			while($row = db_getrow($result))
			{
				$mid = db_dequote($row['mark_id']);
				$url = db_dequote($row['url']);
				$title = db_dequote($row['title']);
				$comment = db_dequote($row['comment']);
				$created = db_dequote($row['created']);
				$parent = db_dequote($row['parent']);

				/* Print the outer stuff if we're new */
				if($mid!=$lastbm)
				{
					if($first==0)
						print("  </bookmark>\n");
					else
						$first=0;

					/* Do a few requisite entity subs */
					$url = ereg_replace("&", "&amp;", $url);
					$url = ereg_replace("<", "&lt;", $url);
					$title = ereg_replace("&", "&amp;", $title);
					$title = ereg_replace("<", "&lt;", $title);
					$comment = ereg_replace("&", "&amp;", $comment);
					$comment = ereg_replace("<", "&lt;", $comment);
					print("  <bookmark id=\"$mid\">\n"
					    . "   <url>$url</url>\n"
					    . "   <title>$title</title>\n"
					    . "   <comment>$comment</comment>\n"
					    . "   <created>$created</created>\n");
					$lastbm = $mid;
				}

				/* We always have parents to describe */
				if(is_numeric($parent))
					print("   <parent id=\"$parent\" />\n");
			}
			if($lastbm != -1)
				print("  </bookmark>\n");
			print(" </bookmarks>\n");

			/* That's it */
			print("</htbmbak>\n");
			exit(0);
		}
		else if($bakmode == "upload")
		{
			/* Upload a backup and insert it */
			print_head("Bookmark Administration", $rcsid);

			/*
			 * NOTES:
			 * PHP4 provides a DOM interface to XML (libxml) via the DOM
			 * XML extension. PHP5 provides a DOM interface using libxml
			 * via the XML extension, which is *DIFFERENT*, just to fuck
			 * with us.  PHP5 also provides a SimpleXML interface, but
			 * that's only in PHP5.  So, my only hope of NOT having to
			 * rewrite and completely screw with this is to use the expat
			 * interface which is the same in both, and which I deeply
			 * hate.
			 *
			 * So, I'm going to write to the PHP4 DOM-XML interface.
			 * Some reworking will be needed for PHP5 whenever it becomes
			 * widespread enough to be worth breaking PHP4 for.  Sigh.
			 */
			$inpfile = $_FILES['userfile']['tmp_name'];
			$backlink = "<p>"
						. "<a href=\"$self?conf=$confenc&amp;amode=backup\">"
						. "Back</a></p>\n";
			if(!is_uploaded_file($inpfile))
			{
				/* Something's broken: Shouldn't happen */
				print("<h1>Error: Can't find file</h1>\n"
						. $backlink);
				print_foot();
				exit(1);
			}

			/* Parse it out */
			if(!($xml = domxml_open_file($inpfile)))
			{
				/* Can't parse file; probably user error */
				print("<h1>Error: Can't parse backup</h1>\n"
						. "<p>Are you sure that's the right file?</p>\n"
						. $backlink);
				print_foot();
				exit(1);
			}

			/* Start walking it */
			$root = $xml->document_element();
			if($root->tagname != "htbmbak")
			{
				/* This doesn't seem like the right kind of file... */
				print("<h1>Error: Can't parse backup</h1>\n"
						. "<p>Expected 'htmbak', got '"
						. $root->tagname . "'</p>\n"
						. "<p>Are you sure that's the right file?</p>\n"
						. $backlink);
				print_foot();
				exit(1);
			}


			/*
			 * First parse the categories
			 */
			$xmlcats = $root->get_elements_by_tagname("categories");
			$xmlcats = $xmlcats[0];
			/* This shouldn't happen */
			if(!$xmlcats || ($xmlcats->tagname != "categories"))
			{
				/* This doesn't seem like the right kind of file... */
				print("<h1>Error: Can't parse backup</h1>\n"
						. "<p>Expected 'categories', got '"
						. $xmlcats->tagname . "'</p>\n"
						. $backlink);
				print_foot();
				exit(1);
			}

			/* We have SOME categories, right?? */
			$cats = $xmlcats->get_elements_by_tagname("category");
			if(!$cats)
			{
				/* We really need at least one category... */
				print("<h1>Error: Can't parse backup</h1>\n"
						. "<p>No categories found; that can't be right</p>\n"
						. $backlink);
				print_foot();
				exit(1);
			}

			/* Start iterating */
			$categories = array();
			$ncats = count($cats);
			for($i=0 ; $i<$ncats ; $i++)
			{
				$cat = $cats[$i];

				/* Shouldn't happen */
				if($cat->tagname != "category")
				{
					print("<h1>Error: Can't parse backup</h1>\n"
							. "<p>Expecting 'category', found '"
							. $cat->tagname . "'</p>\n"
							. $backlink);
					print_foot();
					exit(1);
				}

				$id = $cat->get_attribute("id");
				$name = $cat->get_attribute("name");

				/* Be harsh if we lack something */
				if($id=="" || $name=="")
				{
					print("<h1>Error: Can't parse backup</h1>\n"
							. "<p>id and/or name not found for category.</p>"
							. $backlink);
					print_foot();
					exit(1);
				}

				/* Link it in */
				$categories[$id]['name'] = $name;
				$categories[$id]['parents'] = array();

				/* See what parents it has */
				$parents = $cat->get_elements_by_tagname("parent");
				/* There may or may not be any */
				$npar = count($parents);
				for($j=0 ; $j<$npar ; $j++)
				{
					$parent = $parents[$j];

					/* Get its parent id */
					$pid = $parent->get_attribute("id");
					
					/* We better've got it...  */
					if($pid=="")
					{
						print("<h1>Error: Can't parse backup</h1>\n"
								. "<p>id not found for parent of "
								. "category.</p>" . $backlink);
						print_foot();
						exit(1);
					}

					/* Note it */
					array_push($categories[$id]['parents'], $pid);

					/* Move on */
				} /* parents */
			} /* categories */

			/* Make sure there's a root category */
			if(!is_array($categories["0"]))
			{
				
				print("<h1>Error: Can't parse backup</h1>\n"
						. "<p>No root category found.</p>"
						. $backlink);
				print_foot();
				exit(1);
			}

			/* Make sure every category can be traced back to the root */
			foreach($categories as $cid => $cat)
			{
				if(_check_root_path($cid)==0)
				{
					/* It lacks a path */
					print("<h1>Error</h1>\n"
							. "<p>Category '$cid' ("
							. htmlentities($cat['name']) . ")"
							. "isn't connected to the root category."
							. "</p>\n");
					print_foot();
					exit(1);
				}
			}


			/*
			 * Now parse the bookmarks.
			 */
			$xmlbms = $root->get_elements_by_tagname("bookmarks");
			$xmlbms = $xmlbms[0];
			/* This shouldn't happen */
			if(!$xmlbms || ($xmlbms->tagname != "bookmarks"))
			{
				/* This doesn't seem like the right kind of file... */
				print("<h1>Error: Can't parse backup</h1>\n"
						. "<p>Expected 'bookmarks', got '"
						. $xmlbms->tagname . "'</p>\n"
						. $backlink);
				print_foot();
				exit(1);
			}

			/* We don't necessarily have to have any bookmarks... */
			$bms = $xmlbms->get_elements_by_tagname("bookmark");
			if(is_array($bms))
				$nbms = count($bms);
			else
				$nbms = 0;

			$bookmarks = array();
			for($i=0 ; $i<$nbms ; $i++)
			{
				$bm = $bms[$i];

				/* Shouldn't happen */
				if($bm->tagname != "bookmark")
				{
					print("<h1>Error: Can't parse backup</h1>\n"
							. "<p>Expecting 'bookmark', found '"
							. $bm->tagname . "'</p>\n"
							. $backlink);
					print_foot();
					exit(1);
				}

				/* Get the info about it */
				$id = $bm->get_attribute("id");

				/* This isn't optional */
				if(!$id || (strlen($id)<1))
				{
					print("<h1>Error: Can't parse backup</h1>\n"
							. "<p>No id found for bookmark.</p>"
							. $backlink);
					print_foot();
					exit(1);
				}

				/* URL (only 1) */
				$xmlurl = $bm->get_elements_by_tagname("url");
				$xurl = $xmlurl[0]->child_nodes();
				$nu = count($xurl);
				if($nu==1)
					$url = $xurl[0]->get_content();
				else
					$url = "";

				/* Title (only 1) */
				$xmltitle = $bm->get_elements_by_tagname("title");
				$xtitle = $xmltitle[0]->child_nodes();
				$nu = count($xtitle);
				if($nu==1)
					$title = $xtitle[0]->get_content();
				else
					$title = "";

				/* Comment (only 1) */
				$xmlcomment = $bm->get_elements_by_tagname("comment");
				$xcomment = $xmlcomment[0]->child_nodes();
				$nu = count($xcomment);
				if($nu==1)
					$comment = $xcomment[0]->get_content();
				else
					$comment = "";

				/* Created (only 1) */
				$xmlcreated = $bm->get_elements_by_tagname("created");
				$xcreated = $xmlcreated[0]->child_nodes();
				$nu = count($xcreated);
				if($nu==1)
					$created = $xcreated[0]->get_content();
				else
					$created = "";

				/* URL needs to be set; the rest technically don't */
				if(!$url || (strlen($url)<1))
				{
					print("<h1>Error: Can't parse backup</h1>\n"
							. "<p>No url found for bookmark.</p>"
							. $backlink);
					print_foot();
					exit(1);
				}

				/* Stick 'em together before we find the parents */
				$bookmarks[$id]['url'] = $url;
				$bookmarks[$id]['title'] = $title;
				$bookmarks[$id]['comment'] = $comment;
				$bookmarks[$id]['created'] = $created;
				$bookmarks[$id]['parents'] = array();

				/* Now look up the parents */
				$parents = $bm->get_elements_by_tagname("parent");
				$npar = count($parents);
				for($j=0 ; $j<$npar ; $j++)
				{
					$parent = $parents[$j];

					/* Get its parent id */
					$pid = $parent->get_attribute("id");
					
					/* We better've got it...  */
					if($pid=="")
					{
						print("<h1>Error: Can't parse backup</h1>\n"
								. "<p>id not found for parent of "
								. "bookmark.</p>" . $backlink);
						print_foot();
						exit(1);
					}

					/* Note it */
					array_push($bookmarks[$id]['parents'], $pid);

					/* Move on */
				} /* parents */
			} /* bookmarks */


			/*
			 * Now start actually ADDING stuff
			 */
			/* Give a new identity to the root */
			$newroot = $_REQUEST['newparent'];
			$categories['0']['newid'] = $newroot;

			/* Start me up! */
			db_query("BEGIN");

			/* Add the categories */
			foreach($categories as $cid => $cat)
			{
				/* Don't insert our faked up root */
				if($cid==0)
					continue;

				/* Insert */
				$name_q = db_quote($cat['name']);
				$cid_q = "nextval('categories_cat_id_seq')";
				$query = "INSERT INTO categories (cat_id,name) "
						. "VALUES ($cid_q,$name_q)";
				db_query($query);

				/* Get the new ID */
				$cid_q = "currval('categories_cat_id_seq')";
				$query = "SELECT $cid_q AS cid";
				$result = db_query($query);
				$row = db_getrow($result);
				$categories[$cid]['newid'] = db_dequote($row['cid']);
				db_qfree($result);
			}

			/* Now start resolving the links */
			foreach($categories as $dummy => $cat)
			{
				if($cid==0)
					continue;

				$cid_q = db_quote($cat['newid']);
				foreach($cat['parents'] as $dummy => $id)
				{
					$parent_q = db_quote($categories[$id]['newid']);
					$query = "INSERT INTO cat_links (cat_id,parent) "
							. "VALUES($cid_q,$parent_q)";
					db_query($query);
				}
			}

			/* Next, add in the bookmarks */
			foreach($bookmarks as $mid => $mark)
			{
				/* Insert */
				$markid_q = "nextval('bookmarks_mark_id_seq')";
				$url_q = db_quote($mark['url']);
				$title_q = db_quote($mark['title']);
				$comment_q = db_quote($mark['comment']);
				if(strlen($mark['created'])>0)
					$created_q = db_quote($mark['created']);
				else
					$created_q = "NOW()";

				$query = "INSERT INTO bookmarks (mark_id,url,title,"
						. "comment,created) VALUES ($markid_q,$url_q,"
						. "$title_q,$comment_q,$created_q)";
				db_query($query);

				/* Link it to its parents */
				$markid_q = "currval('bookmarks_mark_id_seq')";
				foreach($mark['parents'] as $dummy => $pid)
				{
					$parent_q = db_quote($categories[$pid]['newid']);
					$query = "INSERT INTO bm_links (mark_id,parent) "
							. "VALUES ($markid_q, $parent_q)";
					db_query($query);
				}
			}

			/* That should be it */
			db_query("COMMIT");


			/* Temporary */
			print <<< _EOF_
<h1>Bookmarks imported!</h1>
<p>
 <a href="bookmarks.php?conf=$confenc">Back to Bookmarks</a>
</p>

_EOF_;
			print_foot();
			exit(0);
		}
		else
		{
			/* Show form */
			print_head("Bookmark Administration", $rcsid);
			print <<< _EOF_
<h1>Bookmark backup</h1>
<ul>
 <li>
  <a href="$self?conf=$confenc&amp;amode=backup&amp;bakmode=download">
   Download a backup of current bookmarks</a>
 </li>
 <li>
  <form method="post" enctype="multipart/form-data" action="$self">
   <p>Restore a backup</p>
   <ul>
    <li>File: <input type="file" name="userfile"></li>
    <li>
     Category to import into:
     <select name="newparent">
      <option value="0">Bookmarks</option>
_EOF_;
			select_listkids(0, 0, build_categories());
			print <<< _EOF_

     </select>
    <li>
     <input type="hidden" name="conf" value="$confenc">
     <input type="hidden" name="amode" value="backup">
     <input type="hidden" name="bakmode" value="upload">
     <input type="submit" name="submit" value="Restore">
    </li>
   </ul>
  </form>
 </ul>
 </li>
</ul>
<form method="get" action="bookmarks.php">
 <p>
  <input type="hidden" name="conf" value="$confenc" />
  <input type="submit" name="dummy" value="Back to Bookmarks" />
 </p>
</form>

_EOF_;

			/* That's all we need here */
			print_foot();
			exit(0);
		}
	}

	/* We should never get here */
	print_head("Bookmark Administration :: Error", $rcsid);
	print <<< _EOF_
<h1>Internal error</h1>
<p>What the hell?</p>
<p><a href="bookmarks.php?conf=$confenc#$bounceback">Back to bookmarks</a></p>

_EOF_;
	exit(1);

	/* That's all, folks */

/*
 * Various internal functions
 */
/* Make sure the given category has a path back to the root */
function _check_root_path($cid)
{
	global $categories;

	/* ARE we the root? */
	if($cid==0)
		return(1);

	/* Directly under root? */
	if(in_array("0", $categories[$cid]['parents']))
		return(1);
	
	if(is_array($categories[$cid]['parents']))
		foreach($categories[$cid]['parents'] as $dummy => $pid)
			if(_check_root_path($pid)==1)
				return(1);

	/* If we get here, it's not under root.  Dammit. */
	return(0);
}
