<?php
/* $Fuller: myprograms/htbm/web/php/listkids.php,v 1.32 2004/12/14 17:32:51 fullermd Exp $ */

/* Show children */
function listkids($cid)
{
	global $conf;
	global $confenc;
	global $categories;
	global $self;
	global $db;
	global $catpath;

	$thekids = $categories[$cid]['children'];
	if(!$thekids)
	{ return; }

	print("<ul>\n");

	/* Start looking */
	foreach($thekids as $dummy => $thevalue)
	{
		/* This probably shouldn't happen */
		if($thevalue==0)
		{ continue; }

		/* Update our path */
		$catpath .= "-$thevalue";

		/* Do we have kids or bookmarks? */
		$havekids = $categories[$thevalue]['has_children'];
		$havemarks = $categories[$thevalue]['has_bookmarks'];
		if($havekids>0 || $havemarks>0)
		{
			/* Check expansion */
			if(in_array($thevalue, $conf['expanders']))
			{
				/* Show subparts and 'collapse' image */
				$showmore=1;
				$img="minus";
				$ialt="-";
				$expthis = -($thevalue);
			} else {
				/* Don't show subparts */
				$showmore=0;
				$img="plus";
				$ialt="+";
				$expthis = $thevalue;
			}

			$indimg = "<a href=\"$self?conf=$confenc&amp;"
					. "expand=$expthis#$catpath\">"
					. "<img src=\"images/$img.png\" "
					. "height=\"11\" width=\"11\" alt=\"$ialt\" "
					. "class=\"expcol\" /></a>";
		}
		else
		{
			$showmore=0;
			$indimg = '<img src="images/dot.png" height="11" '
					. 'width="11" alt="*" class="expcol" />';
		}
		printf("<li id=\"$catpath\" class=\"category\">%s %s", $indimg,
				htmlentities($categories[$thevalue]['name']));

		if($conf['admin']==1)
		{
			print("<span class=\"bmadmin\"> ");
			if($conf['debug']==1)
				print("($thevalue) ");
			print("[<a href=\"bmadmin.php?cat_id=$thevalue&amp;"
					. "amode=catedit&amp;conf=$confenc"
					. "&amp;bounceback=$catpath\">Edit</a>] "
					. "[<a href=\"bmadmin.php?cat_id=$thevalue&amp;"
					. "amode=catdele&amp;conf=$confenc"
					. "&amp;bounceback=$catpath\">Delete</a>]"
					. "</span>");
		}

		print("\n");

		if($showmore==1 || $conf['expandall']==1)
		{
			/* List any child categories */
			listkids($thevalue);

			/* And list the bookmarks */
			listmarks($thevalue);
		}

		print("</li>\n");

		/* Now backstep the path */
		$catpath = ereg_replace("-[0-9]+$", "", $catpath);
	}

	print("</ul>\n");
}

?>
