<?php
/* $Fuller: myprograms/htbm/web/php/admin.php,v 1.16 2004/12/11 18:34:15 fullermd Exp $ */

/* Administrative functions */

/* Print appropriate links */
function print_admin()
{
	global $self;
	global $conf;
	global $confenc;

	print("<ul class=\"metalink\">\n");

	if($conf['admin']==1)
	{
		/* We're in administrative mode */
		print <<< _EOF_
 <li>
  <a href="$self?conf=$confenc&amp;admin=0">Leave admin mode</a>
 </li>
 <li>
  <a href="bmadmin.php?amode=edit&amp;mark_id=0&amp;conf=$confenc">
   Add new bookmark</a>
 </li>
 <li>
  <a href="bmadmin.php?amode=catedit&amp;cat_id=0&amp;conf=$confenc">
   Add new category</a>
 </li>
 <li>
  <a href="bmadmin.php?amode=backup&amp;conf=$confenc">
   Backups</a>
 </li>

_EOF_;
	}
	else
		print("<a href=\"$self?conf=$confenc&amp;admin=1\">"
				. "Enter admin mode</a>\n");

	print("</ul>\n");
}

/* Do authentication if called for */
function admin_auth()
{
	global $db;

	$newinfo=0;
	$htauth = unserialize(base64_decode($_COOKIE['HTBMauth']));

	if(!isset($htauth) || !is_array($htauth)
			|| !isset($htauth['user']) || !isset($htauth['pass']))
	{
		/* See if we've got stuff in the incoming headers */
		$user = $_REQUEST['htuser'];
		$pass = $_REQUEST['htpass'];

		if(!isset($user) || !isset($pass))
			print_unauth(0); /* Doesn't return */

		/* If we've got 'em, set 'em in the structure */
		$htauth['user'] = $user;
		$htauth['pass'] = $pass;
		$newinfo=1;
	}

	/* Authenticate user */
	$auser = $_SERVER['PHP_AUTH_USER'];
	$user_q = db_quote($htauth['user']);
	$querystr = "SELECT password FROM users WHERE username=$user_q";
	$result = db_query($querystr);

	if(db_numrows($result)==0)
		print_unauth(1);

	$row = db_getrow($result);
	if(db_dequote($row['password']) != $htauth['pass'])
		print_unauth(1);

	/* If we get to here, the passwords match */
	db_qfree($result);

	/* If this is new info, set a new cookie */
	if($newinfo==1)
		setcookie("HTBMauth", base64_encode(serialize($htauth)));
	return;
}

/* Print the authentication failed thingie */
function print_unauth($failed)
{
	global $confenc, $conf, $self;

	/* Allow a 'no-admin' backlink */
	$conf2 = $conf;
	$conf2['admin']=0;
	$confenc_2 = base64_encode(serialize($conf2));

	if($failed==1)
		$headstr = "<h1>Login failed!</h1>";
	else
		$headstr = "<h1>Admin login</h1>";

	print_head("Login", "");
	print <<< _EOF_
$headstr
<form method="post" action="$self">
 <ul>
  <li>Username: <input type="text" size="16" name="htuser"></li>
  <li>Password: <input type="password" size="16" name="htpass"></li>
 </ul>
 <p>
  <input type="hidden" name="conf" value="$confenc">
  <input type="submit" name="go" value="Login">
 </p>
</form>
<form method="post" action="$self">
<p>
 <input type="hidden" name="conf" value="$confenc_2">
 <input type="submit" name="go" value="Leave admin">
</p>

_EOF_;
	print_foot();

	/* Don't return */
	exit(0);
}
