<?php
/* $Fuller: myprograms/htbm/web/php/admin_bmark.php,v 1.24 2004/12/14 19:51:38 fullermd Exp $ */

/* Admin stuff for bookmarks */
$alreadysel = 0;
$cdepth = 0;

/* Print out a form for new/edit bookmark, and RO version for delete */
function print_bmark_form($bminfo)
{
	global $db;
	global $alreadysel;
	global $cdepth;
	global $amode;
	global $confenc;
	global $self;

	$mark_id = $bminfo['mark_id'];
	$url = $bminfo['url'];
	$title = $bminfo['title'];
	$comment = $bminfo['comment'];
	$parents = $bminfo['parents'];


	/* Mark info */
	/* XXX This should be prettified.  A lot. */
	$url_e = htmlentities($url);
	$title_e = htmlentities($title);
	$comment_e = htmlentities($comment);

	if($amode=="dele")
		$ro = " readonly=\"readonly\" ";
	else
		$ro = "";

	if($amode=="edit")
	{
		print <<< _EOF_
<h2>General</h2>
<form action="$self" method="post">

_EOF_;
		if($mark_id>0)
			$cat_tit = <<< _EOF_
</ul>
<p>
 <input type="hidden" name="amode" value="$amode" />
 <input type="hidden" name="mark_id" value="$mark_id" />
 <input type="hidden" name="conf" value="$confenc" />
 <input type="submit" name="commit" value="Commit" />
</p>
</form>
<h2>Categories</h2>
<ul>

_EOF_;
	}
	else
		$cat_tit = "";

	print <<< _EOF_
<ul>
 <li>
  URL:
  <input type="text" size="70" name="url" value="$url_e" $ro/>
 </li>
 <li>
  Title:
  <input type="text" size="70" name="title" value="$title_e" $ro/>
 </li>
 <li>
  Comment:
  <textarea style="display:block;" name="comment"
    rows="3" cols="60"$ro>$comment_e</textarea>
 </li>
$cat_tit

_EOF_;

	/* Recurse through parents */
	$i=0;
	$categories = build_categories();
	foreach($parents as $dummy => $thisparent)
	{
		if($amode=="dele")
		{
			/* Just list 'em */
			print("<li>Category: " . htmlentities($thisparent)
					. "</li>\n");
		}
		else
		{

			print(" <li>\n");

			if($mark_id>0)
				print <<< _EOF_
  <form method="post" action="$self">
   <p>
    Category:
    <select name="parent">
_EOF_;
			else
				print("  Parent category: <select name=\"parent\">");

			/* Special-case the top-level */
			if($thisparent==0)
			{ $seld = " selected=\"selected\""; }
			else
			{ $seld = ""; }

			/* Top level */
			print("<option value=\"0\"$seld>Bookmarks</option>");

			/* Print the rest */
			$alreadysel=0;
			$cdepth=1;
			select_listkids(0,$thisparent,$categories);

			print("</select>\n");

			if($mark_id>0)
				print <<< _EOF_
    <input type="hidden" name="conf" value="$confenc" />
    <input type="hidden" name="mark_id" value="$mark_id" />
    <input type="hidden" name="amode" value="$amode" />
    <input type="hidden" name="old_parent" value="$thisparent" />
    <input type="submit" name="ed_chcat" value="Update" />
    <input type="submit" name="ed_delcat" value="Delete" />
   </p>
  </form>
_EOF_;

			/* Common */
			print(" </li>\n");

			/* Done categories */
		}

		/* Loop around to the next category in the list */
		$i++;
	}
	print("</ul>\n");

	/* If we're in edit mode, allow adding another */
	if( ($mark_id>0) && ($amode=="edit") )
	{
		print <<< _EOF_
<h2>Add new category</h2>
<ul>
 <li>
  <form method="post" action="$self">
   <p>
    Category:
    <select name="parent">
_EOF_;
		/* Top level */
		print("<option value=\"0\">Bookmarks</option>\n");

		/* Print the rest */
		/* XXX Hack, no selected'ing */
		$cdepth=1;
		select_listkids(0,-1,$categories);

		/* Done categories */
		print <<< _EOF_
</select>
    <input type="hidden" name="mark_id" value="$mark_id" />
    <input type="hidden" name="amode" value="$amode" />
    <input type="hidden" name="conf" value="$confenc" />
    <input type="submit" name="ed_addcat" value="Add" />
   </p>
  </form>
 </li>
</ul>

_EOF_;
	}
	else if( ($mark_id==0) && ($amode=="edit") )
		/* In new mode, just give the submit */
		print <<< _EOF_
<p>
 <input type="hidden" name="amode" value="$amode" />
 <input type="hidden" name="mark_id" value="$mark_id" />
 <input type="hidden" name="conf" value="$confenc" />
 <input type="submit" name="commit" value="Commit" />
</p>
</form>

_EOF_;

	/* Fin */
}

/* List kids of a given cid in <select> output format */
/*
 * XXX
 * This is stolen pretty much verbatim from listkids.php.  We really
 * should find a way of merging as much as possible of these to make
 * future maintenance easier.
 */
function select_listkids($cid,$whichsel,$categories)
{
	global $alreadysel, $cdepth;

	$thekids = $categories[$cid]['children'];
	if(!$thekids)
	{ return; }

	foreach($thekids as $dummy => $thevalue)
	{
		d_print("<!-- Starting on kid $thevalue -->\n");
		if($thevalue==0)
		{ continue; }

		/* Find our distance from the 'root' */
		if($thevalue!=0)
		{
			$tmpcat = $categories[$thevalue];
			$cdtmp = $cdepth;
			$leader = "";
			while(($cdtmp--)>0)
				$leader .= "&nbsp;";
		}

		/* Should we be selected? */
		if( ($thevalue==$whichsel) && ($alreadysel==0) )
		{
			$seld = " selected=\"selected\"";
			$alreadysel=1;
		}
		else
			$seld = "";

		/* Print ourselves out */
		$myname = htmlentities($categories[$thevalue]['name']);
		if(strlen($myname)>30)
			$myname = substr($myname, 0, 30) . "...";
		print("<option value=\"$thevalue\"$seld>$leader$myname</option>");

		/* Do we have children? */
		$havekids = $categories[$thevalue]['has_children'];
		if($havekids>0)
		{
			$cdepth++;
			select_listkids($thevalue,$whichsel,$categories);
			$cdepth--;
		}
	}
}
