<?php
/* $Fuller: myprograms/htbm/web/php/bookmarks.php,v 1.3 2004/12/14 12:13:26 fullermd Exp $ */

/* Build our bookmarks ref array */
function build_bookmarks()
{
	global $debug;
	global $db;

	/* Initialize just to be sure */
	$bookmarks = array();

	/* Grab all the info about the bookmarks */
	$query = "SELECT mark_id,url,title,comment,created "
			. "FROM bookmarks";
	$result = db_query($query);
	while($row = db_getrow($result))
	{
		$mid = db_dequote($row['mark_id']);
		$url = db_dequote($row['url']);
		$title = db_dequote($row['title']);
		$comment = db_dequote($row['comment']);
		$created = db_dequote($row['created']);

		$bookmarks[$mid]['url'] = $url;
		$bookmarks[$mid]['title'] = $title;
		$bookmarks[$mid]['comment'] = $comment;
		$bookmarks[$mid]['created'] = $created;
	}
	db_qfree($result);


	return($bookmarks);
}
